/*Definiciones de los numeros en hexadecimal de las cabeceras de todos
  los registros documentados en la informacion de los .OBJ, naturalmente,
  para un enlace no son necesarios la mayoria de estos, reduciendolos
  notablemente, en caso de encontrar un registro no soportado, se ignoraria
  y se trataria de continuar si no fuera posible, se edtendria el enlace y
  se daria un error donde no se pueda continuar aparte de la notificacion de
  dicho registro.*/

/*Notese de que los registros para modo protegido son impares y que la
  longitud de algunos campos se duplican*/


#define RHEADR   0x6E /*R-Module Header Record*/
#define REGINT   0x70 /*Register Initialization Record*/
#define REDATA   0x72
#define RIDATA   0x74
#define OVLDEF   0x76
#define ENDREC   0x78
#define BLKDEF   0x7A
#define BLKEND   0x7C
#define DEBSYM   0x7E
#define THEADR   0x80  /*cabecera de los obj*/
#define LHEADR   0x82
#define PEDATA   0x84
#define PIDATA   0x86
#define COMENT   0x88
#define MODEND   0x8A /*Fin de modulo*/
#define PMODEND  0x8B /*fin de modulo en modo protegido*/
#define TYPDEF   0x8E
#define LOCSYM   0x92
#define LINNUM   0x94
#define PLINNUM  0x95
#define GRPDEF   0x9A /*Definicion de grupo*/
#define UNNAMED  0x9E /*Registro sin nombre, sin uso*/
#define LIBHED   0x0A4
#define LIBNAM   0x0A6
#define LIBLOC   0x0A8
#define LIBDIC   0x0AA
#define COMDEF   0x0B0
#define BAKPAT   0x0B2
#define PBAKPAT  0x0B3
#define LEXTDEF  0x0B4
#define LPUBDEF  0x0B6
#define PLPUBDEF 0x0B7
#define LCOMDEF  0x0B8
#define COMFIX   0x0BA
#define PCOMFIX  0x0BB
#define CEXTDEF  0x0BC
#define SELDEF   0x0C0
#define COMDAT   0x0C2
#define PCOMDAT  0x0C3
#define LINSYM   0x0C4
#define PLINSYM  0x0C5
#define ALIAS    0x0C6
#define NBKPAT   0x0C8
#define PNBKPAT  0x0C9
#define LLNAMES  0x0CA
#define LIBHR    0x0F0
#define LIBER    0x0F1



/*Estas definiciones se utilizan para realizar mascaras a nivel de bit,
  Muy utiles para cuando los campos se miden a nivel de bits*/
#define BIT7    0x80
#define BIT6    0x40
#define BIT5    0x20
#define BIT4    0x10
#define BIT3    0x08
#define BIT2    0x04
#define BIT1    0x02
#define BIT0    0x01

/*byte, tipo de dato muy necesitado que se puede asignar a un char, pero
  corriendo el riesgo que el compilador le de signo, de esta forma, el
  byte sera un tipo de 8 bits sin signo*/
#define byte unsigned char
