#include <malloc.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include "externo.h"
#include "index.h"

void insertaE(externo  **lista,unsigned char  *nombre,unsigned short indice)
{
  externo  *nuevo, *aux=*lista;/*Aux se utiliza para clarificar, es
				       prescindible*/
  extdef  *elemento;

  /*reservamos memoria en caso de no haber, dmos el error y salimos*/
  if ((nuevo=(externo   *)malloc(sizeof(externo )))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  /*reservamos memoria en caso de no haber, dmos el error y salimos*/
  if ((elemento=(extdef   *)malloc(sizeof(extdef )))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  /*actualizamos los valores*/
  elemento->nombre=nombre;
  elemento->Tipoindice=indice;
  nuevo->Edatos=elemento;
  nuevo->Cdatos=NULL;
  if (aux!=NULL)/*si es el primero, el indice debe ser 1, sino el indice sera
		  el indice del ultimo +1*/
    nuevo->napa=aux->napa+1;
  else
    nuevo->napa=1;
  nuevo->sig=aux;
  *lista=nuevo;
}

void liberaE(externo  *lista)
{
  if (lista!=NULL){
  /*buscamos el ultimo*/
  if (lista->sig!=NULL) liberaE(lista->sig);
  /*una vez encontramos liberamos la memoria*/
  if (lista->Edatos!=NULL) free(lista->Edatos->nombre);
  free(lista->Edatos);
  if (lista->Cdatos!=NULL) free(lista->Cdatos->nombre);
  free(lista->Cdatos);
  free(lista);}
}

void Extdef(externo  **lista,FILE *fp,unsigned short tamanio)
/*Extdef es un registro que guarda la informacion de los nombres
  referenciados a modulos externos, es decir, que se encuentran en otros
  modulos.
  Estas refrencias aparecen en un orden que es almacenado en forma de indice
  de 1-N, para que pueda ser buscadas por el nombre en otros modulos y
  referenciadas por medio del registro de enlace
  En caso de que hubiera mas de un registro, estos se aadirian a partir de
  la lista ya formada, aunque no es muy comun puede darse.
  Cada modulo tiene su propio registro de referencias externas, no son
  compartidos con otros modulos*/

{
unsigned char tam,aux, *cadena;
unsigned short int indi;

while(tamanio>1)
  {
    /*leemeos el tamao de la cadena*/
    tam=fgetc(fp);
    /*reservamos memoria para el tamao+1, siendo el aadido '\0'*/
    if ((cadena=(unsigned char  *)malloc(tam+1))==NULL)
       {printf("Falta memoria"); exit(0);}
    /*actualizamos memoria*/
    for(aux=0;aux<tam;aux++) cadena[aux]=fgetc(fp);
    cadena[aux]='\0';
    /*obtenemos el indice*/
    tamanio-=(tam+1+indice(fp,&indi));
    /*insertamos en la lista*/
    insertaE(lista, cadena,indi);
  }
/*En el caso de que el fichero sea erroneo, medido en la lectura de
caracteres, damos el error y salimos*/
if (tamanio<=0){printf("El fichero dado es erroneo!!!"); exit(0);}
fgetc(fp);
}

/*inserta un elemento en la lista*/
void insertaC(externo  **lista, unsigned char  *nombre,unsigned char tam,
              unsigned short Tipoindice, unsigned char tipo,
              unsigned  long tamano,unsigned short elementos)

{
  externo  *nuevo, *aux=*lista;/*Aux se utiliza para clarificar, es
				       prescindible*/
  comdat  * elemento;

  /*reservamos memoria en caso de no haber, dmos el error y salimos*/
  if ((nuevo=(externo  *)malloc(sizeof(externo)))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  /*reservamos memoria en caso de no haber, dmos el error y salimos*/
  if ((elemento=(comdat   *)malloc(sizeof(comdat )))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  /*actualizamos los valores*/
  elemento->nombre=nombre;
  elemento->tam=tam;
  elemento->Tipoindice=Tipoindice;
  elemento->tipo=tipo;
  elemento->tamano=tamano;
  elemento->elementos=elementos;
  nuevo->Cdatos=elemento;
  nuevo->Edatos=NULL;
  if (aux!=NULL)/*si es el primero, el indice debe ser 1, sino el indice sera
		  el indice del ultimo +1*/
    nuevo->napa=aux->napa+1;
  else
    nuevo->napa=1;

  nuevo->sig=aux;
  *lista=nuevo;
}


void Comdef(externo  **Lista,FILE *fp, unsigned short tamanio)
/*El registro Comdef es aquel del que obtenenmos la informacion de las
variables estaticas definidas en el modulo y locales a el, siendo dicha
informacion, el nombre, el tipo, el tipo de dato ( o near), el numero
de elemetos y su tamao. Este registro esta ordenado por ocurrencia con
el fin de ser referenciado por el registro de enlace.
Si encontraramos un nombre publico en otro modulo o en el mismo modulo con
el mismo nombre que alguna variable, dariamos un error de duplicidad de
nombres*/
{
unsigned char tipodato,tam, *cadena,aux;
unsigned short tipoindex;
unsigned long num_elem=0, size_elem;

 while (tamanio>1)
 {
   tam=fgetc(fp);
   tamanio-=tam;
   if ((cadena=(unsigned char  *)malloc(tam))==NULL)
     {printf("No hay memoria suficiente"); exit(0);}
   for(aux=0;aux<tam;aux++) cadena[aux]=fgetc(fp);
   tamanio-=indice(fp,&tipoindex)+1;
   tipodato=fgetc(fp);
   if (tipodato == 0x61) /* dato de tipo  */
     {
       tamanio-=recogetam(fp,&num_elem);
       tamanio-=recogetam(fp,&size_elem);
     }
   else/*dato de tipo Near*/
       tamanio-=recogetam(fp,&size_elem);
 }
 insertaC(Lista,cadena,tam,tipoindex,tipodato,num_elem,size_elem);
 fgetc(fp);/*sumatorio*/
}

unsigned char recogetam(FILE *fp,unsigned long *aux)
{
  unsigned char c;

  switch (c=fgetc(fp))
    {
      case 0x81:(*aux)=fgetc(fp)+(fgetc(fp)<<8);
		return(3);
      case 0x82:(*aux)=fgetc(fp)+(fgetc(fp)<<8)+(fgetc(fp)<<16);
		return(4);
      case 0x83:(*aux)=(fgetc(fp)+(fgetc(fp)<<8))+(fgetc(fp)+(fgetc(fp)<<8)<<8);
		return(5);
      default  :(*aux)=c;
		return(1);
    }
}

