#include <malloc.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include "publico.h"
#include "index.h"

/*Inserta un elemento en la lista*/
void insertaP(publicos **lista,defini *estru,unsigned short seg,unsigned short frame)
{
  publicos *nuevo, *aux=*lista;

  if ((nuevo=(publicos  *)malloc(sizeof(publicos)))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  nuevo->frame=frame;
  nuevo->seg=seg;
  nuevo->datos=estru;
  nuevo->sig=aux;
  *lista=nuevo;
}

/*libera la estructura y la subestructura*/
void liberaP(publicos  *lista)
{
  if (lista!=NULL){
  if (lista->sig!=NULL)  liberaP(lista->sig);
  if (lista->datos!=NULL) liberaPd(lista->datos);
  free(lista);}
}

/*inserta un elemento en la subestructura*/
void insertaPd(defini  **lista,unsigned char  *nombre,unsigned short desp,unsigned short tipo)
{
  defini  *nuevo, *aux=*lista;

  if ((nuevo=(defini  *)malloc(sizeof(defini)))==NULL)
      {
	printf("No hay memoria suficiente");
	exit(0);
      }
  nuevo->nombre=nombre;
  nuevo->desp=desp;
  nuevo->tipo=tipo;
  nuevo->sig=aux;
  *lista=nuevo;
}

/*libera la subestructura*/
void liberaPd(defini  *lista)
{
  if (lista!=NULL){
if (lista->sig!=NULL) liberaPd(lista->sig);
free(lista->nombre);
free(lista);}
}

/*El registro de definicion publica, es un registro que nos indica
  un nombre publico con el fin de resolver las direcciones de enlace
  Este registro indica no solo el nombre en ASCII, sino que ademas indica
  un indice al segmento, su desplazamiento en el y algunos datos mas de
  importancia.
  */
void Pubdef(publicos  **Lista,FILE *fp,unsigned short tamanio)
{
unsigned short grupo,seg,offset,tipo;
unsigned short frame=0;
unsigned char tam,i, *cadena;
defini  *sublista=NULL;

   tamanio-=indice(fp,&grupo);/*tomamos el grupo*/
   tamanio-=indice(fp,&seg);  /*tomamos el segmento*/
   if (seg==0)                /*Si el segmento es cero tomamos el frame*/
    {
       char alto,bajo;
       bajo=fgetc(fp);
       alto=fgetc(fp);
       frame=bajo+(alto<<8);
       tamanio-=2;
    }

   while (tamanio>1) /*mientras haya nombres por leer*/
    {
       tam=fgetc(fp);/*leemos el tamaos de la cadena*/
       cadena=(unsigned char  *)malloc(tam+1);/*reservamos memoria*/
       for(i=0;i<tam;i++) cadena[i]=fgetc(fp);/*obtenemos la cadena*/
       cadena[i]='\0'; /*la finalizamos*/
       tamanio-= tam+3;
       char alto,bajo;
       bajo=fgetc(fp);
       alto=fgetc(fp);
       offset = bajo+(alto<<8);/*tomamos el depslazamiento*/
       tamanio-=indice(fp,&tipo);/*tomamos el tipo*/
       insertaPd(&sublista,cadena,offset,tipo);/*lo insertamos en la lista*/
    }
   insertaP(Lista,sublista,seg,frame);
   if (tamanio<1) {printf("El fichero dado es erroneo!!!"); exit(0);}
   fgetc(fp);
}
